a684f98807c685ccf7ad6c94d3a6673b6197db46
[fio.git] / t / zbd / test-zbd-support
1 #!/bin/bash
2 #
3 # Copyright (C) 2018 Western Digital Corporation or its affiliates.
4 #
5 # This file is released under the GPL.
6
7 usage() {
8         echo "Usage: $(basename "$0") [OPTIONS] <test target device file>"
9         echo "Options:"
10         echo -e "\t-d Run fio with valgrind using DRD tool"
11         echo -e "\t-e Run fio with valgrind using helgrind tool"
12         echo -e "\t-v Run fio with valgrind --read-var-info option"
13         echo -e "\t-l Test with libzbc ioengine"
14         echo -e "\t-r Reset all zones before test start"
15         echo -e "\t-o <max_open_zones> Run fio with max_open_zones limit"
16         echo -e "\t-t <test #> Run only a single test case with specified number"
17         echo -e "\t-q Quit the test run after any failed test"
18         echo -e "\t-z Run fio with debug=zbd option"
19 }
20
21 max() {
22     if [ "$1" -gt "$2" ]; then
23         echo "$1"
24     else
25         echo "$2"
26     fi
27 }
28
29 min() {
30     if [ "$1" -lt "$2" ]; then
31         echo "$1"
32     else
33         echo "$2"
34     fi
35 }
36
37 ioengine() {
38         if [ -n "$use_libzbc" ]; then
39                 echo -n "--ioengine=libzbc"
40         else
41                 echo -n "--ioengine=$1"
42         fi
43 }
44
45 set_io_scheduler() {
46     local dev=$1 sched=$2
47
48     [ -e "/sys/block/$dev" ] || return $?
49     if [ -e "/sys/block/$dev/mq" ]; then
50         case "$sched" in
51             noop)        sched=none;;
52             deadline)    sched=mq-deadline;;
53         esac
54     else
55         case "$sched" in
56             none)        sched=noop;;
57             mq-deadline) sched=deadline;;
58         esac
59     fi
60
61     echo "$sched" >"/sys/block/$dev/queue/scheduler"
62 }
63
64 check_read() {
65     local read
66
67     read=$(fio_read <"${logfile}.${test_number}")
68     echo "read: $read <> $1" >> "${logfile}.${test_number}"
69     [ "$read" = "$1" ]
70 }
71
72 check_written() {
73     local written
74
75     written=$(fio_written <"${logfile}.${test_number}")
76     echo "written: $written <> $1" >> "${logfile}.${test_number}"
77     [ "$written" = "$1" ]
78 }
79
80 # Compare the reset count from the log file with reset count $2 using operator
81 # $1 (=, -ge, -gt, -le, -lt).
82 check_reset_count() {
83     local reset_count
84
85     reset_count=$(fio_reset_count <"${logfile}.${test_number}")
86     echo "reset_count: test $reset_count $1 $2" >> "${logfile}.${test_number}"
87     eval "[ '$reset_count' '$1' '$2' ]"
88 }
89
90 # Check log for failed assertions and crashes. Without these checks,
91 # a test can succeed even when these events happen, but it must fail.
92 check_log() {
93      [ ! -f "${logfile}.${1}" ] && return 0
94      ! grep -q -e "Assertion " -e "Aborted " "${logfile}.${1}"
95 }
96
97 # Whether or not $1 (/dev/...) is a SCSI device.
98 is_scsi_device() {
99     local d f
100
101     d=$(basename "$dev")
102     for f in /sys/class/scsi_device/*/device/block/"$d"; do
103         [ -e "$f" ] && return 0
104     done
105     return 1
106 }
107
108 job_var_opts_exclude() {
109         local o
110         local ex_key="${1}"
111
112         for o in "${job_var_opts[@]}"; do
113                 if [[ ${o} =~ "${ex_key}" ]]; then
114                         continue
115                 fi
116                 echo -n "${o}"
117         done
118 }
119
120 has_max_open_zones() {
121         while (($# > 1)); do
122                 if [[ ${1} =~ "--max_open_zones" ]]; then
123                         return 0
124                 fi
125                 shift
126         done
127         return 1
128 }
129
130 run_fio() {
131     local fio opts
132
133     fio=$(dirname "$0")/../../fio
134
135     opts=(${global_var_opts[@]})
136     opts+=("--max-jobs=16" "--aux-path=/tmp" "--allow_file_create=0" \
137                            "--significant_figures=10" "$@")
138     # When max_open_zones option is specified to this test script, add
139     # max_open_zones option to fio command unless the test case already add it.
140     if [[ -n ${max_open_zones_opt} ]] && ! has_max_open_zones "${opts[@]}"; then
141             opts+=("--max_open_zones=${max_open_zones_opt}")
142     fi
143     { echo; echo "fio ${opts[*]}"; echo; } >>"${logfile}.${test_number}"
144
145     "${dynamic_analyzer[@]}" "$fio" "${opts[@]}"
146 }
147
148 run_one_fio_job() {
149     local r
150
151     r=$(((RANDOM << 16) | RANDOM))
152     run_fio --name="$dev" --filename="$dev" "$@" --randseed="$r"        \
153             --thread=1 --direct=1
154 }
155
156 write_and_run_one_fio_job() {
157     local r
158     local write_offset="${1}"
159     local write_size="${2}"
160     local -a write_opts
161
162     shift 2
163     r=$(((RANDOM << 16) | RANDOM))
164     write_opts=(--name="write_job" --rw=write "$(ioengine "psync")" \
165                       --bs="${logical_block_size}" --zonemode=zbd \
166                       --zonesize="${zone_size}" --thread=1 --direct=1 \
167                       --offset="${write_offset}" --size="${write_size}")
168     write_opts+=("${job_var_opts[@]}")
169     run_fio --filename="$dev" --randseed="$r" "${write_opts[@]}" \
170             --name="$dev" --wait_for="write_job" "$@" --thread=1 --direct=1
171 }
172
173 # Run fio on the first four sequential zones of the disk.
174 run_fio_on_seq() {
175     local opts=()
176
177     opts+=("--offset=$((first_sequential_zone_sector * 512))")
178     opts+=("--size=$((4 * zone_size))" "--zonemode=zbd")
179     if [ -z "$is_zbd" ]; then
180         opts+=("--zonesize=${zone_size}")
181     fi
182     run_one_fio_job "${opts[@]}" "$@"
183 }
184
185 # Prepare for write test by resetting zones. When max_open_zones option is
186 # specified, reset all zones of the test target to ensure that zones out of the
187 # test target range do not have open zones. This allows the write test to the
188 # target range to be able to open zones up to max_open_zones.
189 prep_write() {
190         [[ -n "${max_open_zones_opt}" && -n "${is_zbd}" ]] &&
191                 reset_zone "${dev}" -1
192 }
193
194 SKIP_TESTCASE=255
195
196 require_scsi_dev() {
197         if ! is_scsi_device "$dev"; then
198                 SKIP_REASON="$dev is not a SCSI device"
199                 return 1
200         fi
201         return 0
202 }
203
204 require_conv_zone_bytes() {
205         local req_bytes=${1}
206
207         if ((req_bytes > first_sequential_zone_sector * 512)); then
208                 SKIP_REASON="$dev does not have enough conventional zones"
209                 return 1
210         fi
211         return 0
212 }
213
214 require_zbd() {
215         if [[ -z ${is_zbd} ]]; then
216                 SKIP_REASON="$dev is not a zoned block device"
217                 return 1
218         fi
219         return 0
220 }
221
222 require_regular_block_dev() {
223         if [[ -n ${is_zbd} ]]; then
224                 SKIP_REASON="$dev is not a regular block device"
225                 return 1
226         fi
227         return 0
228 }
229
230 require_seq_zones() {
231         local req_seq_zones=${1}
232         local seq_bytes=$((disk_size - first_sequential_zone_sector * 512))
233
234         if ((req_seq_zones > seq_bytes / zone_size)); then
235                 SKIP_REASON="$dev does not have $req_seq_zones sequential zones"
236                 return 1
237         fi
238         return 0
239 }
240
241 require_conv_zones() {
242         local req_c_zones=${1}
243         local conv_bytes=$((first_sequential_zone_sector * 512))
244
245         if ((req_c_zones > conv_bytes / zone_size)); then
246                 SKIP_REASON="$dev does not have $req_c_zones conventional zones"
247                 return 1
248         fi
249         return 0
250 }
251
252 # Check whether buffered writes are refused.
253 test1() {
254     run_fio --name=job1 --filename="$dev" --rw=write --direct=0 --bs=4K \
255             "$(ioengine "psync")" --size="${zone_size}" --thread=1      \
256             --zonemode=zbd --zonesize="${zone_size}" 2>&1 |
257         tee -a "${logfile}.${test_number}" |
258         grep -q 'Using direct I/O is mandatory for writing to ZBD drives'
259     local fio_rc=${PIPESTATUS[0]} grep_rc=${PIPESTATUS[2]}
260     case "$fio_rc" in
261         0|1) ;;
262         *)   return "$fio_rc"
263     esac
264     if [ -n "$is_zbd" ]; then
265         [ "$grep_rc" = 0 ]
266     else
267         [ "$grep_rc" != 0 ]
268     fi
269 }
270
271 # Block size exceeds zone size.
272 test2() {
273     local bs off opts=() rc
274
275     off=$(((first_sequential_zone_sector + 2 * sectors_per_zone) * 512))
276     bs=$((2 * zone_size))
277     opts+=("$(ioengine "psync")")
278     opts+=("--name=job1" "--filename=$dev" "--rw=write" "--direct=1")
279     opts+=("--zonemode=zbd" "--offset=$off" "--bs=$bs" "--size=$bs")
280     if [ -z "$is_zbd" ]; then
281         opts+=("--zonesize=${zone_size}")
282     fi
283     run_fio "${opts[@]}" >> "${logfile}.${test_number}" 2>&1 && return 1
284     grep -q 'buflen exceeds zone size' "${logfile}.${test_number}"
285 }
286
287 # Run fio against an empty zone. This causes fio to report "No I/O performed".
288 test3() {
289     local off opts=() rc
290
291     require_seq_zones 129 || return $SKIP_TESTCASE
292     off=$((first_sequential_zone_sector * 512 + 128 * zone_size))
293     size=$((zone_size))
294     [ -n "$is_zbd" ] && reset_zone "$dev" $((off / 512))
295     opts+=("--name=$dev" "--filename=$dev" "--offset=$off" "--bs=4K")
296     opts+=("--size=$size" "--zonemode=zbd")
297     opts+=("$(ioengine "psync")" "--rw=read" "--direct=1" "--thread=1")
298     if [ -z "$is_zbd" ]; then
299         opts+=("--zonesize=${zone_size}")
300     fi
301     run_fio "${opts[@]}" >> "${logfile}.${test_number}" 2>&1 || return $?
302     ! grep -q 'READ:' "${logfile}.${test_number}"
303 }
304
305 # Run fio with --read_beyond_wp=1 against an empty zone.
306 test4() {
307     local off opts=()
308
309     require_seq_zones 130 || return $SKIP_TESTCASE
310     off=$((first_sequential_zone_sector * 512 + 129 * zone_size))
311     size=$((zone_size))
312     [ -n "$is_zbd" ] && reset_zone "$dev" $((off / 512))
313     opts+=("--name=$dev" "--filename=$dev" "--offset=$off" "--bs=$size")
314     opts+=("--size=$size" "--thread=1" "--read_beyond_wp=1")
315     opts+=("$(ioengine "psync")" "--rw=read" "--direct=1" "--disable_lat=1")
316     opts+=("--zonemode=zbd" "--zonesize=${zone_size}")
317     run_fio "${opts[@]}" >> "${logfile}.${test_number}" 2>&1 || return $?
318     check_read $size || return $?
319 }
320
321 # Sequential write to sequential zones.
322 test5() {
323     local size off capacity
324
325     prep_write
326     off=$((first_sequential_zone_sector * 512))
327     capacity=$(total_zone_capacity 4 $off $dev)
328     size=$((4 * zone_size))
329     run_fio_on_seq "$(ioengine "psync")" --iodepth=1 --rw=write \
330                    --bs="$(max $((zone_size / 64)) "$logical_block_size")"\
331                    --do_verify=1 --verify=md5                           \
332                    >>"${logfile}.${test_number}" 2>&1 || return $?
333     check_written $capacity || return $?
334     check_read $capacity || return $?
335 }
336
337 # Sequential read from sequential zones.
338 test6() {
339     local size off capacity
340
341     prep_write
342     off=$((first_sequential_zone_sector * 512))
343     capacity=$(total_zone_capacity 4 $off $dev)
344     size=$((4 * zone_size))
345     write_and_run_one_fio_job \
346             $((first_sequential_zone_sector * 512)) "${size}" \
347             --offset="${off}" \
348             --size="${size}" --zonemode=zbd --zonesize="${zone_size}" \
349             "$(ioengine "psync")" --iodepth=1 --rw=read \
350             --bs="$(max $((zone_size / 64)) "$logical_block_size")" \
351             >>"${logfile}.${test_number}" 2>&1 || return $?
352     check_read $capacity || return $?
353 }
354
355 # Random write to sequential zones, libaio, queue depth 1.
356 test7() {
357     local size=$((zone_size))
358     local off capacity
359
360     prep_write
361     off=$((first_sequential_zone_sector * 512))
362     capacity=$(total_zone_capacity 1 $off $dev)
363     run_fio_on_seq "$(ioengine "libaio")" --iodepth=1 --rw=randwrite    \
364                    --bs="$(min 16384 "${zone_size}")"                   \
365                    --do_verify=1 --verify=md5 --size="$size"            \
366                    >>"${logfile}.${test_number}" 2>&1 || return $?
367     check_written $capacity || return $?
368     check_read $capacity || return $?
369 }
370
371 # Random write to sequential zones, libaio, queue depth 64.
372 test8() {
373     local size off capacity
374
375     prep_write
376     size=$((4 * zone_size))
377     off=$((first_sequential_zone_sector * 512))
378     capacity=$(total_zone_capacity 4 $off $dev)
379     run_fio_on_seq "$(ioengine "libaio")" --iodepth=64 --rw=randwrite   \
380                    --bs="$(min 16384 "${zone_size}")"                   \
381                    --do_verify=1 --verify=md5                           \
382                    >>"${logfile}.${test_number}" 2>&1 || return $?
383     check_written $capacity || return $?
384     check_read $capacity || return $?
385 }
386
387 # Random write to sequential zones, sg, queue depth 1.
388 test9() {
389     local size
390
391     require_scsi_dev || return $SKIP_TESTCASE
392
393     prep_write
394     size=$((4 * zone_size))
395     run_fio_on_seq --ioengine=sg                                        \
396                    --iodepth=1 --rw=randwrite --bs=16K                  \
397                    --do_verify=1 --verify=md5                           \
398                    >>"${logfile}.${test_number}" 2>&1 || return $?
399     check_written $size || return $?
400     check_read $size || return $?
401 }
402
403 # Random write to sequential zones, sg, queue depth 64.
404 test10() {
405     local size
406
407     require_scsi_dev || return $SKIP_TESTCASE
408
409     prep_write
410     size=$((4 * zone_size))
411     run_fio_on_seq --ioengine=sg                                        \
412                    --iodepth=64 --rw=randwrite --bs=16K                 \
413                    --do_verify=1 --verify=md5                           \
414                    >>"${logfile}.${test_number}" 2>&1 || return $?
415     check_written $size || return $?
416     check_read $size || return $?
417 }
418
419 # Random write to sequential zones, libaio, queue depth 64, random block size.
420 test11() {
421     local size off capacity
422
423     prep_write
424     size=$((4 * zone_size))
425     off=$((first_sequential_zone_sector * 512))
426     capacity=$(total_zone_capacity 4 $off $dev)
427     run_fio_on_seq "$(ioengine "libaio")" --iodepth=64 --rw=randwrite   \
428                    --bsrange=4K-64K --do_verify=1 --verify=md5          \
429                    --debug=zbd >>"${logfile}.${test_number}" 2>&1 || return $?
430     check_written $capacity || return $?
431     check_read $capacity || return $?
432 }
433
434 # Random write to sequential zones, libaio, queue depth 64, max 1 open zone.
435 test12() {
436     local size off capacity
437
438     prep_write
439     size=$((8 * zone_size))
440     off=$((first_sequential_zone_sector * 512))
441     capacity=$(total_zone_capacity 8 $off $dev)
442     run_fio_on_seq "$(ioengine "libaio")" --iodepth=64 --rw=randwrite --bs=16K \
443                    --max_open_zones=1 --size=$size --do_verify=1 --verify=md5 \
444                    --debug=zbd >>"${logfile}.${test_number}" 2>&1 || return $?
445     check_written $capacity || return $?
446     check_read $capacity || return $?
447 }
448
449 # Random write to sequential zones, libaio, queue depth 64, max 4 open zones.
450 test13() {
451     local size off capacity
452
453     prep_write
454     size=$((8 * zone_size))
455     off=$((first_sequential_zone_sector * 512))
456     capacity=$(total_zone_capacity 8 $off $dev)
457     run_fio_on_seq "$(ioengine "libaio")" --iodepth=64 --rw=randwrite --bs=16K \
458                    --max_open_zones=4 --size=$size --do_verify=1 --verify=md5 \
459                    --debug=zbd                                                \
460                    >>"${logfile}.${test_number}" 2>&1 || return $?
461     check_written $capacity || return $?
462     check_read $capacity || return $?
463 }
464
465 # Random write to conventional zones.
466 test14() {
467     local off size
468
469     if ! result=($(first_online_zone "$dev")); then
470         echo "Failed to determine first online zone"
471         exit 1
472     fi
473     off=${result[0]}
474     prep_write
475     size=$((16 * 2**20)) # 20 MB
476     require_conv_zone_bytes "${size}" || return $SKIP_TESTCASE
477
478     run_one_fio_job "$(ioengine "libaio")" --iodepth=64 --rw=randwrite --bs=16K \
479                     --zonemode=zbd --zonesize="${zone_size}" --do_verify=1 \
480                     --verify=md5 --offset=$off --size=$size\
481                     >>"${logfile}.${test_number}" 2>&1 || return $?
482     check_written $((size)) || return $?
483     check_read $((size)) || return $?
484 }
485
486 # Sequential read on a mix of empty and full zones.
487 test15() {
488     local i off size
489     local w_off w_size w_capacity
490
491     for ((i=0;i<4;i++)); do
492         [ -n "$is_zbd" ] &&
493             reset_zone "$dev" $((first_sequential_zone_sector +
494                                  i*sectors_per_zone))
495     done
496     prep_write
497     w_off=$(((first_sequential_zone_sector + 2 * sectors_per_zone) * 512))
498     w_size=$((2 * zone_size))
499     w_capacity=$(total_zone_capacity 2 $w_off $dev)
500     off=$((first_sequential_zone_sector * 512))
501     size=$((4 * zone_size))
502     write_and_run_one_fio_job "${w_off}" "${w_size}" \
503                     "$(ioengine "psync")" --rw=read --bs=$((zone_size / 16)) \
504                     --zonemode=zbd --zonesize="${zone_size}" --offset=$off \
505                     --size=$((size)) >>"${logfile}.${test_number}" 2>&1 ||
506         return $?
507     check_written $((w_capacity)) || return $?
508     check_read $((w_capacity))
509 }
510
511 # Random read on a mix of empty and full zones.
512 test16() {
513     local off size
514     local i w_off w_size w_capacity
515
516     for ((i=0;i<4;i++)); do
517         [ -n "$is_zbd" ] &&
518             reset_zone "$dev" $((first_sequential_zone_sector +
519                                  i*sectors_per_zone))
520     done
521     prep_write
522     w_off=$(((first_sequential_zone_sector + 2 * sectors_per_zone) * 512))
523     w_size=$((2 * zone_size))
524     w_capacity=$(total_zone_capacity 2 $w_off $dev)
525     off=$((first_sequential_zone_sector * 512))
526     size=$((4 * zone_size))
527     write_and_run_one_fio_job "${w_off}" "${w_size}" \
528                     "$(ioengine "libaio")" --iodepth=64 --rw=randread --bs=16K \
529                     --zonemode=zbd --zonesize="${zone_size}" --offset=$off \
530                     --size=$size >>"${logfile}.${test_number}" 2>&1 || return $?
531     check_written $w_capacity || return $?
532     check_read $size || return $?
533 }
534
535 # Random reads and writes in the last zone.
536 test17() {
537     local io off last read size written
538
539     off=$(((disk_size / zone_size - 1) * zone_size))
540     size=$((disk_size - off))
541     if ! last=($(last_online_zone "$dev")); then
542         echo "Failed to determine last online zone"
543         exit 1
544     fi
545     if [[ "$((last * 512))" -lt "$off" ]]; then
546         off=$((last * 512))
547         size=$zone_size
548     fi
549     if [ -n "$is_zbd" ]; then
550         reset_zone "$dev" $((off / 512)) || return $?
551     fi
552     prep_write
553     run_one_fio_job "$(ioengine "libaio")" --iodepth=8 --rw=randrw --bs=4K \
554                     --zonemode=zbd --zonesize="${zone_size}"            \
555                     --offset=$off --loops=2 --norandommap=1 \
556                     --size="$size"\
557                     >>"${logfile}.${test_number}" 2>&1 || return $?
558     written=$(fio_written <"${logfile}.${test_number}")
559     read=$(fio_read <"${logfile}.${test_number}")
560     io=$((written + read))
561     echo "Total number of bytes read and written: $io <> $size" \
562          >>"${logfile}.${test_number}"
563     [ $io = $((size * 2)) ];
564 }
565
566 # Out-of-range zone reset threshold and frequency parameters.
567 test18() {
568     run_fio_on_seq --zone_reset_threshold=-1 |&
569         tee -a "${logfile}.${test_number}"   |
570             grep -q 'value out of range' || return $?
571 }
572
573 test19() {
574     run_fio_on_seq --zone_reset_threshold=2  |&
575         tee -a "${logfile}.${test_number}"   |
576         grep -q 'value out of range' || return $?
577 }
578
579 test20() {
580     run_fio_on_seq --zone_reset_threshold=.4:.6 |&
581         tee -a "${logfile}.${test_number}"   |
582         grep -q 'the list exceeding max length' || return $?
583 }
584
585 test21() {
586     run_fio_on_seq --zone_reset_frequency=-1 |&
587         tee -a "${logfile}.${test_number}"   |
588         grep -q 'value out of range' || return $?
589 }
590
591 test22() {
592     run_fio_on_seq --zone_reset_frequency=2  |&
593         tee -a "${logfile}.${test_number}"   |
594         grep -q 'value out of range' || return $?
595 }
596
597 test23() {
598     run_fio_on_seq --zone_reset_frequency=.4:.6  |&
599         tee -a "${logfile}.${test_number}"   |
600         grep -q 'the list exceeding max length' || return $?
601 }
602
603 test24() {
604     local bs loops=9 size=$((zone_size))
605     local off capacity
606
607     prep_write
608     off=$((first_sequential_zone_sector * 512))
609     capacity=$(total_zone_capacity 1 $off $dev)
610
611     bs=$(min $((256*1024)) "$zone_size")
612     run_fio_on_seq "$(ioengine "psync")" --rw=write --bs="$bs"          \
613                    --size=$size --loops=$loops                          \
614                    --zone_reset_frequency=.01 --zone_reset_threshold=.90 \
615                    >> "${logfile}.${test_number}" 2>&1 || return $?
616     check_written $((capacity * loops)) || return $?
617     check_reset_count -eq 8 ||
618         check_reset_count -eq 9 ||
619         check_reset_count -eq 10 || return $?
620 }
621
622 # Multiple non-overlapping sequential write jobs for the same drive.
623 test25() {
624     local i opts=()
625
626     for ((i=0;i<16;i++)); do
627         [ -n "$is_zbd" ] &&
628             reset_zone "$dev" $((first_sequential_zone_sector + i*sectors_per_zone))
629     done
630     prep_write
631     for ((i=0;i<16;i++)); do
632         opts+=("--name=job$i" "--filename=$dev" "--thread=1" "--direct=1")
633         opts+=("--offset=$((first_sequential_zone_sector*512 + zone_size*i))")
634         opts+=("--size=$zone_size" "$(ioengine "psync")" "--rw=write" "--bs=16K")
635         opts+=("--zonemode=zbd" "--zonesize=${zone_size}" "--group_reporting=1")
636         opts+=(${job_var_opts[@]})
637     done
638     run_fio "${opts[@]}" >> "${logfile}.${test_number}" 2>&1 || return $?
639 }
640
641 write_to_first_seq_zone() {
642     local loops=4 r
643     local off capacity
644
645     prep_write
646     off=$((first_sequential_zone_sector * 512))
647     capacity=$(total_zone_capacity 1 $off $dev)
648
649     r=$(((RANDOM << 16) | RANDOM))
650     run_fio --name="$dev" --filename="$dev" "$(ioengine "psync")" --rw="$1" \
651             --thread=1 --do_verify=1 --verify=md5 --direct=1 --bs=4K    \
652             --offset=$off                                               \
653             --size=$zone_size --loops=$loops --randseed="$r"            \
654             --zonemode=zbd --zonesize="${zone_size}" --group_reporting=1        \
655             --gtod_reduce=1 >> "${logfile}.${test_number}" 2>&1 || return $?
656     check_written $((loops * capacity)) || return $?
657 }
658
659 # Overwrite the first sequential zone four times sequentially.
660 test26() {
661     write_to_first_seq_zone write
662 }
663
664 # Overwrite the first sequential zone four times using random writes.
665 test27() {
666     write_to_first_seq_zone randwrite
667 }
668
669 # Multiple overlapping random write jobs for the same drive.
670 test28() {
671     local i jobs=16 off opts
672
673     require_seq_zones 65 || return $SKIP_TESTCASE
674     off=$((first_sequential_zone_sector * 512 + 64 * zone_size))
675     [ -n "$is_zbd" ] && reset_zone "$dev" $((off / 512))
676     prep_write
677     opts=("--debug=zbd")
678     capacity=$(total_zone_capacity 1 $off $dev)
679     for ((i=0;i<jobs;i++)); do
680         opts+=("--name=job$i" "--filename=$dev" "--offset=$off" "--bs=16K")
681         opts+=("--size=$zone_size" "--io_size=$capacity" "$(ioengine "psync")" "--rw=randwrite")
682         opts+=("--thread=1" "--direct=1" "--zonemode=zbd")
683         opts+=("--zonesize=${zone_size}" "--group_reporting=1")
684         opts+=(${job_var_opts[@]})
685     done
686     run_fio "${opts[@]}" >> "${logfile}.${test_number}" 2>&1 || return $?
687     check_written $((jobs * $capacity)) || return $?
688     check_reset_count -eq $jobs ||
689         check_reset_count -eq $((jobs - 1)) ||
690         return $?
691 }
692
693 # Multiple overlapping random write jobs for the same drive and with a limited
694 # number of open zones.
695 test29() {
696     local i jobs=16 off opts=()
697
698     require_seq_zones 80 || return $SKIP_TESTCASE
699     off=$((first_sequential_zone_sector * 512 + 64 * zone_size))
700     size=$((16*zone_size))
701     prep_write
702     opts=("--debug=zbd")
703     for ((i=0;i<jobs;i++)); do
704         opts+=("--name=job$i" "--filename=$dev" "--offset=$off" "--bs=16K")
705         opts+=("--size=$size" "--io_size=$zone_size" "--thread=1")
706         opts+=("$(ioengine "psync")" "--rw=randwrite" "--direct=1")
707         opts+=("--max_open_zones=4" "--group_reporting=1")
708         opts+=("--zonemode=zbd" "--zonesize=${zone_size}")
709         # max_open_zones is already specified
710         opts+=($(job_var_opts_exclude "--max_open_zones"))
711     done
712     run_fio "${opts[@]}" >> "${logfile}.${test_number}" 2>&1 || return $?
713     check_written $((jobs * zone_size)) || return $?
714 }
715
716 # Random reads and writes across the entire disk for 30s.
717 test30() {
718     local off
719
720     prep_write
721     off=$((first_sequential_zone_sector * 512))
722     run_one_fio_job "$(ioengine "libaio")" --iodepth=8 --rw=randrw      \
723                     --bs="$(max $((zone_size / 128)) "$logical_block_size")"\
724                     --zonemode=zbd --zonesize="${zone_size}" --offset=$off\
725                     --loops=2 --time_based --runtime=30s --norandommap=1\
726                     >>"${logfile}.${test_number}" 2>&1
727 }
728
729 # Random reads across all sequential zones for 30s. This is not only a fio
730 # test but also allows to verify the performance of a drive.
731 test31() {
732     local bs inc nz off opts size
733
734     [ -n "$is_zbd" ] && reset_zone "$dev" -1
735
736     # As preparation, write 128 KB to sequential write required zones. Limit
737     # write target zones up to max_open_zones to keep test time reasonable.
738     # To distribute the write target zones evenly, skip certain zones for every
739     # write. Utilize zonemode strided for such write patterns.
740     bs=$((128 * 1024))
741     nz=$((max_open_zones))
742     if [[ $nz -eq 0 ]]; then
743         nz=128
744     fi
745     off=$((first_sequential_zone_sector * 512))
746     size=$((disk_size - off))
747     inc=$(((size / nz / zone_size) * zone_size))
748     opts=("--name=$dev" "--filename=$dev" "--rw=write" "--bs=${bs}")
749     opts+=("--offset=$off" "--size=$((inc * nz))" "--io_size=$((bs * nz))")
750     opts+=("--zonemode=strided" "--zonesize=${bs}" "--zonerange=${inc}")
751     opts+=("--direct=1")
752     echo "fio ${opts[@]}" >> "${logfile}.${test_number}"
753     "$(dirname "$0")/../../fio" "${opts[@]}" >> "${logfile}.${test_number}" 2>&1
754
755     # Next, run the test.
756     opts=("--name=$dev" "--filename=$dev" "--offset=$off" "--size=$size")
757     opts+=("--bs=$bs" "$(ioengine "psync")" "--rw=randread" "--direct=1")
758     opts+=("--thread=1" "--time_based" "--runtime=30" "--zonemode=zbd")
759     opts+=("--zonesize=${zone_size}")
760     opts+=(${job_var_opts[@]})
761     run_fio "${opts[@]}" >> "${logfile}.${test_number}" 2>&1 || return $?
762 }
763
764 # Random writes across all sequential zones. This is not only a fio test but
765 # also allows to verify the performance of a drive.
766 test32() {
767     local off opts=() size
768
769     require_zbd || return $SKIP_TESTCASE
770
771     prep_write
772     off=$((first_sequential_zone_sector * 512))
773     size=$((disk_size - off))
774     opts+=("--name=$dev" "--filename=$dev" "--offset=$off" "--size=$size")
775     opts+=("--bs=128K" "$(ioengine "psync")" "--rw=randwrite" "--direct=1")
776     opts+=("--thread=1" "--time_based" "--runtime=30")
777     opts+=("--max_open_zones=$max_open_zones" "--zonemode=zbd")
778     opts+=("--zonesize=${zone_size}")
779     run_fio "${opts[@]}" >> "${logfile}.${test_number}" 2>&1 || return $?
780 }
781
782 # Write to sequential zones with a block size that is not a divisor of the
783 # zone size.
784 test33() {
785     local bs io_size size
786     local off capacity=0;
787
788     prep_write
789     off=$((first_sequential_zone_sector * 512))
790     capacity=$(total_zone_capacity 1 $off $dev)
791     size=$((2 * zone_size))
792     io_size=$((5 * capacity))
793     bs=$((3 * capacity / 4))
794     run_fio_on_seq "$(ioengine "psync")" --iodepth=1 --rw=write \
795                    --size=$size --io_size=$io_size --bs=$bs     \
796                    >> "${logfile}.${test_number}" 2>&1 || return $?
797     check_written $(((io_size + bs - 1) / bs * bs)) || return $?
798 }
799
800 # Write to sequential zones with a block size that is not a divisor of the
801 # zone size and with data verification enabled.
802 test34() {
803     local size
804
805     prep_write
806     size=$((2 * zone_size))
807     run_fio_on_seq "$(ioengine "psync")" --iodepth=1 --rw=write --size=$size \
808                    --do_verify=1 --verify=md5 --bs=$((3 * zone_size / 4)) \
809                    >> "${logfile}.${test_number}" 2>&1 && return 1
810     grep -q 'not a divisor of' "${logfile}.${test_number}"
811 }
812
813 # Test 1/4 for the I/O boundary rounding code: $size < $zone_size.
814 test35() {
815     local bs off io_size size
816
817     prep_write
818     off=$(((first_sequential_zone_sector + 1) * 512))
819     size=$((zone_size - 2 * 512))
820     bs=$((zone_size / 4))
821     run_one_fio_job --offset=$off --size=$size "$(ioengine "psync")"    \
822                     --iodepth=1 --rw=write --do_verify=1 --verify=md5   \
823                     --bs=$bs --zonemode=zbd --zonesize="${zone_size}"   \
824                     >> "${logfile}.${test_number}" 2>&1 && return 1
825     grep -q 'io_size must be at least one zone' "${logfile}.${test_number}"
826 }
827
828 # Test 2/4 for the I/O boundary rounding code: $size < $zone_size.
829 test36() {
830     local bs off io_size size
831
832     prep_write
833     off=$(((first_sequential_zone_sector) * 512))
834     size=$((zone_size - 512))
835     bs=$((zone_size / 4))
836     run_one_fio_job --offset=$off --size=$size "$(ioengine "psync")"    \
837                     --iodepth=1 --rw=write --do_verify=1 --verify=md5   \
838                     --bs=$bs --zonemode=zbd --zonesize="${zone_size}"   \
839                     >> "${logfile}.${test_number}" 2>&1 && return 1
840     grep -q 'io_size must be at least one zone' "${logfile}.${test_number}"
841 }
842
843 # Test 3/4 for the I/O boundary rounding code: $size > $zone_size.
844 test37() {
845     local bs off size capacity
846
847     prep_write
848     capacity=$(total_zone_capacity 1 $((first_sequential_zone_sector*512)) $dev)
849     if [ "$first_sequential_zone_sector" = 0 ]; then
850         off=0
851     else
852         off=$(((first_sequential_zone_sector - 1) * 512))
853     fi
854     size=$((zone_size + 2 * 512))
855     bs=$((zone_size / 4))
856     run_one_fio_job --offset=$off --size=$size "$(ioengine "psync")"    \
857                     --iodepth=1 --rw=write --do_verify=1 --verify=md5   \
858                     --bs=$bs --zonemode=zbd --zonesize="${zone_size}"   \
859                     >> "${logfile}.${test_number}" 2>&1
860     check_written $capacity || return $?
861 }
862
863 # Test 4/4 for the I/O boundary rounding code: $offset > $disk_size - $zone_size
864 test38() {
865     local bs off size
866
867     prep_write
868     size=$((logical_block_size))
869     off=$((disk_size - logical_block_size))
870     bs=$((logical_block_size))
871     run_one_fio_job --offset=$off --size=$size "$(ioengine "psync")"    \
872                     --iodepth=1 --rw=write --do_verify=1 --verify=md5   \
873                     --bs=$bs --zonemode=zbd --zonesize="${zone_size}"   \
874                     >> "${logfile}.${test_number}" 2>&1 && return 1
875     grep -q 'io_size must be at least one zone' "${logfile}.${test_number}"
876 }
877
878 # Read one block from a block device.
879 read_one_block() {
880     local off
881     local bs
882
883     if ! result=($(first_online_zone "$dev")); then
884         echo "Failed to determine first online zone"
885         exit 1
886     fi
887     off=${result[0]}
888     bs=$((logical_block_size))
889     run_one_fio_job --rw=read "$(ioengine "psync")" --offset=$off --bs=$bs \
890                     --size=$bs "$@" 2>&1 |
891         tee -a "${logfile}.${test_number}"
892 }
893
894 # Check whether fio accepts --zonemode=none for zoned block devices.
895 test39() {
896     require_zbd || return $SKIP_TESTCASE
897     read_one_block --zonemode=none >/dev/null || return $?
898     check_read $((logical_block_size)) || return $?
899 }
900
901 # Check whether fio accepts --zonemode=strided for zoned block devices.
902 test40() {
903     local bs
904
905     bs=$((logical_block_size))
906     require_zbd || return $SKIP_TESTCASE
907     read_one_block --zonemode=strided |
908         grep -q 'fio: --zonesize must be specified when using --zonemode=strided' ||
909         return $?
910     read_one_block --zonemode=strided --zonesize=$bs >/dev/null || return $?
911     check_read $bs || return $?
912 }
913
914 # Check whether fio checks the zone size for zoned block devices.
915 test41() {
916     require_zbd || return $SKIP_TESTCASE
917     read_one_block --zonemode=zbd --zonesize=$((2 * zone_size)) |
918         grep -q 'job parameter zonesize.*does not match disk zone size'
919 }
920
921 # Check whether fio handles --zonesize=0 correctly for regular block devices.
922 test42() {
923     require_regular_block_dev || return $SKIP_TESTCASE
924     read_one_block --zonemode=zbd --zonesize=0 |
925         grep -q 'Specifying the zone size is mandatory for regular block devices with --zonemode=zbd'
926 }
927
928 # Check whether fio handles --zonesize=1 correctly for regular block devices.
929 test43() {
930     require_regular_block_dev || return $SKIP_TESTCASE
931     read_one_block --zonemode=zbd --zonesize=1 |
932         grep -q 'zone size must be at least 512 bytes for --zonemode=zbd'
933 }
934
935 # Check whether fio handles --zonemode=none --zonesize=1 correctly.
936 test44() {
937     read_one_block --zonemode=none --zonesize=1 |
938         grep -q 'fio: --zonemode=none and --zonesize are not compatible'
939 }
940
941 test45() {
942     local bs i
943
944     require_zbd || return $SKIP_TESTCASE
945     prep_write
946     bs=$((logical_block_size))
947     run_one_fio_job "$(ioengine "psync")" --iodepth=1 --rw=randwrite --bs=$bs\
948                     --offset=$((first_sequential_zone_sector * 512)) \
949                     --size="$zone_size" --do_verify=1 --verify=md5 2>&1 |
950         tee -a "${logfile}.${test_number}" |
951         grep -q "fio: first I/O failed. If .* is a zoned block device, consider --zonemode=zbd"
952 }
953
954 # Random write to sequential zones, libaio, 8 jobs, queue depth 64 per job
955 test46() {
956     local size
957
958     prep_write
959     size=$((4 * zone_size))
960     run_fio_on_seq "$(ioengine "libaio")" --iodepth=64 --rw=randwrite --bs=4K \
961                    --group_reporting=1 --numjobs=8 \
962                    >> "${logfile}.${test_number}" 2>&1 || return $?
963     check_written $((size * 8)) || return $?
964 }
965
966 # Check whether fio handles --zonemode=zbd --zoneskip=1 correctly.
967 test47() {
968     local bs
969
970     prep_write
971     bs=$((logical_block_size))
972     run_fio_on_seq "$(ioengine "psync")" --rw=write --bs=$bs --zoneskip=1 \
973                     >> "${logfile}.${test_number}" 2>&1 && return 1
974     grep -q 'zoneskip 1 is not a multiple of the device zone size' "${logfile}.${test_number}"
975 }
976
977 # Multiple overlapping random write jobs for the same drive and with a
978 # limited number of open zones. This is similar to test29, but uses libaio
979 # to stress test zone locking.
980 test48() {
981     local i jobs=16 off opts=()
982
983     require_zbd || return $SKIP_TESTCASE
984     require_seq_zones 80 || return $SKIP_TESTCASE
985
986     off=$((first_sequential_zone_sector * 512 + 64 * zone_size))
987     size=$((16*zone_size))
988     prep_write
989     opts=("--aux-path=/tmp" "--allow_file_create=0" "--significant_figures=10")
990     opts+=("--debug=zbd")
991     opts+=("$(ioengine "libaio")" "--rw=randwrite" "--direct=1")
992     opts+=("--time_based" "--runtime=30")
993     opts+=("--zonemode=zbd" "--zonesize=${zone_size}")
994     opts+=("--max_open_zones=4")
995     for ((i=0;i<jobs;i++)); do
996         opts+=("--name=job$i" "--filename=$dev" "--offset=$off" "--bs=16K")
997         opts+=("--io_size=$zone_size" "--iodepth=256" "--thread=1")
998         opts+=("--size=$size" "--group_reporting=1")
999         # max_open_zones is already specified
1000         opts+=($(job_var_opts_exclude "--max_open_zones"))
1001     done
1002
1003     fio=$(dirname "$0")/../../fio
1004
1005     { echo; echo "fio ${opts[*]}"; echo; } >>"${logfile}.${test_number}"
1006
1007     timeout -v -s KILL 180s \
1008             "${dynamic_analyzer[@]}" "$fio" "${opts[@]}" \
1009             >> "${logfile}.${test_number}" 2>&1 || return $?
1010 }
1011
1012 # Check if fio handles --zonecapacity on a normal block device correctly
1013 test49() {
1014
1015     require_regular_block_dev || return $SKIP_TESTCASE
1016
1017     size=$((2 * zone_size))
1018     capacity=$((zone_size * 3 / 4))
1019
1020     run_one_fio_job "$(ioengine "psync")" --rw=write \
1021                     --zonemode=zbd --zonesize="${zone_size}" \
1022                     --zonecapacity=${capacity} \
1023                     --verify=md5  --size=${size} >>"${logfile}.${test_number}" 2>&1 ||
1024         return $?
1025     check_written $((capacity * 2)) || return $?
1026     check_read $((capacity * 2)) || return $?
1027 }
1028
1029 # Verify that conv zones are not locked and only seq zones are locked during
1030 # random read on conv-seq mixed zones.
1031 test50() {
1032         local off
1033
1034         require_zbd || return $SKIP_TESTCASE
1035         require_conv_zones 8 || return $SKIP_TESTCASE
1036         require_seq_zones 8 || return $SKIP_TESTCASE
1037
1038         reset_zone "${dev}" -1
1039
1040         off=$((first_sequential_zone_sector * 512 - 8 * zone_size))
1041         run_fio --name=job --filename=${dev} --offset=${off} --bs=64K \
1042                 --size=$((16 * zone_size)) "$(ioengine "libaio")" --rw=randread\
1043                 --time_based --runtime=3 --zonemode=zbd --zonesize=${zone_size}\
1044                 --direct=1 --group_reporting=1 ${job_var_opts[@]} \
1045                 >> "${logfile}.${test_number}" 2>&1 || return $?
1046 }
1047
1048 # Verify that conv zones are neither locked nor opened during random write on
1049 # conv-seq mixed zones. Zone lock and zone open shall happen only on seq zones.
1050 test51() {
1051         local off jobs=16
1052         local -a opts
1053
1054         require_zbd || return $SKIP_TESTCASE
1055         require_conv_zones 8 || return $SKIP_TESTCASE
1056         require_seq_zones 8 || return $SKIP_TESTCASE
1057
1058         prep_write
1059
1060         off=$((first_sequential_zone_sector * 512 - 8 * zone_size))
1061         opts+=("--size=$((16 * zone_size))" "$(ioengine "libaio")")
1062         opts+=("--zonemode=zbd" "--direct=1" "--zonesize=${zone_size}")
1063         opts+=("--max_open_zones=2" "--offset=$off")
1064         opts+=("--thread=1" "--group_reporting=1")
1065         opts+=("--time_based" "--runtime=30" "--rw=randwrite")
1066         for ((i=0;i<jobs;i++)); do
1067                 opts+=("--name=job${i}" "--filename=$dev")
1068                 opts+=("--bs=$(((i+1)*16))K")
1069                 opts+=($(job_var_opts_exclude "--max_open_zones"))
1070         done
1071         run_fio "${opts[@]}" >> "${logfile}.${test_number}" 2>&1 || return $?
1072 }
1073
1074 # Verify that zone_reset_threshold only takes logical blocks from seq
1075 # zones into account, and logical blocks of conv zones are not counted.
1076 test52() {
1077         local off io_size
1078
1079         require_zbd || return $SKIP_TESTCASE
1080         require_conv_zones 8 || return $SKIP_TESTCASE
1081         require_seq_zones 8 || return $SKIP_TESTCASE
1082
1083         reset_zone "${dev}" -1
1084
1085         # Total I/O size is 1/8 = 0.125 of the I/O range of cont + seq zones.
1086         # Set zone_reset_threshold as 0.1. The threshold size is less than
1087         # 0.125, then, reset count zero is expected.
1088         # On the other hand, half of the I/O range is covered by conv zones.
1089         # If fio would count the conv zones for zone_reset_threshold, the ratio
1090         # were more than 0.5 and would trigger zone resets.
1091
1092         off=$((first_sequential_zone_sector * 512 - 8 * zone_size))
1093         io_size=$((zone_size * 16 / 8))
1094         run_fio --name=job --filename=$dev --rw=randwrite --bs=$((zone_size/16))\
1095                 --size=$((zone_size * 16)) --softrandommap=1 \
1096                 --io_size=$((io_size)) "$(ioengine "psync")" --offset=$off \
1097                 --zonemode=zbd --direct=1 --zonesize=${zone_size} \
1098                 --zone_reset_threshold=.1 --zone_reset_frequency=1.0 \
1099                 ${job_var_opts[@]} --debug=zbd \
1100                 >> "${logfile}.${test_number}" 2>&1 || return $?
1101
1102         check_written ${io_size} || return $?
1103         check_reset_count -eq 0 || return $?
1104 }
1105
1106 # Check both reads and writes are executed by random I/O to conventional zones.
1107 test53() {
1108         local off capacity io read_b=0 written_b=0
1109
1110         require_zbd || return $SKIP_TESTCASE
1111         require_conv_zones 4 || return $SKIP_TESTCASE
1112
1113         off=$((first_sequential_zone_sector * 512 - 4 * zone_size))
1114         capacity=$(total_zone_capacity 4 $off $dev)
1115         run_fio --name=job --filename=${dev} --rw=randrw --bs=64K \
1116                 --size=$((4 * zone_size)) "$(ioengine "psync")" --offset=${off}\
1117                 --zonemode=zbd --direct=1 --zonesize=${zone_size} \
1118                 ${job_var_opts[@]} \
1119                 >> "${logfile}.${test_number}" 2>&1 || return $?
1120
1121         written_b=$(fio_written <"${logfile}.${test_number}")
1122         read_b=$(fio_read <"${logfile}.${test_number}")
1123         io=$((written_b + read_b))
1124         echo "Number of bytes read: $read_b" >>"${logfile}.${test_number}"
1125         echo "Number of bytes written: $written_b" >>"${logfile}.${test_number}"
1126         echo "Total number of bytes read and written: $io <> $capacity" \
1127              >>"${logfile}.${test_number}"
1128         if ((io==capacity && written_b != 0 && read_b != 0)); then
1129                 return 0
1130         fi
1131         return 1
1132 }
1133
1134 # Test read/write mix with verify.
1135 test54() {
1136         require_zbd || return $SKIP_TESTCASE
1137         require_seq_zones 8 || return $SKIP_TESTCASE
1138
1139         run_fio --name=job --filename=${dev} "$(ioengine "libaio")" \
1140                 --time_based=1 --runtime=30s --continue_on_error=0 \
1141                 --offset=$((first_sequential_zone_sector * 512)) \
1142                 --size=$((8*zone_size)) --direct=1 --iodepth=1 \
1143                 --rw=randrw:2 --rwmixwrite=25 --bsrange=4k-${zone_size} \
1144                 --zonemode=zbd --zonesize=${zone_size} \
1145                 --verify=crc32c --do_verify=1 --verify_backlog=2 \
1146                 --experimental_verify=1 \
1147                 --alloc-size=65536 --random_generator=tausworthe64 \
1148                 ${job_var_opts[@]} --debug=zbd \
1149                 >> "${logfile}.${test_number}" 2>&1 || return $?
1150 }
1151
1152 # test 'z' suffix parsing only
1153 test55() {
1154         local bs
1155         bs=$((logical_block_size))
1156
1157         require_zbd || return $SKIP_TESTCASE
1158         # offset=1z + offset_increment=10z + size=2z
1159         require_seq_zones 13 || return $SKIP_TESTCASE
1160
1161         run_fio --name=j                \
1162                 --filename=${dev}       \
1163                 --direct=1              \
1164                 "$(ioengine "psync")"   \
1165                 --zonemode=zbd          \
1166                 --zonesize=${zone_size} \
1167                 --rw=write              \
1168                 --bs=${bs}              \
1169                 --numjobs=2             \
1170                 --offset_increment=10z  \
1171                 --offset=1z             \
1172                 --size=2z               \
1173                 --io_size=3z            \
1174                 ${job_var_opts[@]} --debug=zbd \
1175                 >> "${logfile}.${test_number}" 2>&1 || return $?
1176 }
1177
1178 # test 'z' suffix parsing only
1179 test56() {
1180         local bs
1181         bs=$((logical_block_size))
1182
1183         require_regular_block_dev || return $SKIP_TESTCASE
1184         require_seq_zones 10 || return $SKIP_TESTCASE
1185
1186         run_fio --name=j                \
1187                 --filename=${dev}       \
1188                 --direct=1              \
1189                 "$(ioengine "psync")"   \
1190                 --zonemode=strided      \
1191                 --zonesize=${zone_size} \
1192                 --rw=write              \
1193                 --bs=${bs}              \
1194                 --size=10z              \
1195                 --zoneskip=2z           \
1196                 ${job_var_opts[@]} --debug=zbd \
1197                 >> "${logfile}.${test_number}" 2>&1 || return $?
1198 }
1199
1200 # Test that repeated async write job does not cause zone reset during writes
1201 # in-flight, when the block size is not a divisor of the zone size.
1202 test57() {
1203         local bs off
1204
1205         require_zbd || return $SKIP_TESTCASE
1206
1207         bs=$((4096 * 7))
1208         off=$((first_sequential_zone_sector * 512))
1209
1210         run_fio --name=job --filename="${dev}" --rw=randwrite --bs="${bs}" \
1211                 --offset="${off}" --size=$((4 * zone_size)) --iodepth=256 \
1212                 "$(ioengine "libaio")" --time_based=1 --runtime=30s \
1213                 --zonemode=zbd --direct=1 --zonesize="${zone_size}" \
1214                 ${job_var_opts[@]} \
1215                 >> "${logfile}.${test_number}" 2>&1 || return $?
1216 }
1217
1218 SECONDS=0
1219 tests=()
1220 dynamic_analyzer=()
1221 reset_all_zones=
1222 use_libzbc=
1223 zbd_debug=
1224 max_open_zones_opt=
1225 quit_on_err=
1226
1227 while [ "${1#-}" != "$1" ]; do
1228   case "$1" in
1229     -d) dynamic_analyzer=(valgrind "--read-var-info=yes" "--tool=drd"
1230                           "--show-confl-seg=no");
1231         shift;;
1232     -e) dynamic_analyzer=(valgrind "--read-var-info=yes" "--tool=helgrind");
1233         shift;;
1234     -l) use_libzbc=1; shift;;
1235     -r) reset_all_zones=1; shift;;
1236     -t) tests+=("$2"); shift; shift;;
1237     -o) max_open_zones_opt="${2}"; shift; shift;;
1238     -v) dynamic_analyzer=(valgrind "--read-var-info=yes");
1239         shift;;
1240     -q) quit_on_err=1; shift;;
1241     -z) zbd_debug=1; shift;;
1242     --) shift; break;;
1243      *) usage; exit 1;;
1244   esac
1245 done
1246
1247 if [ $# != 1 ]; then
1248     usage
1249     exit 1
1250 fi
1251
1252 # shellcheck source=functions
1253 source "$(dirname "$0")/functions" || exit $?
1254
1255 global_var_opts=()
1256 job_var_opts=()
1257 if [ -n "$zbd_debug" ]; then
1258     global_var_opts+=("--debug=zbd")
1259 fi
1260 dev=$1
1261 realdev=$(readlink -f "$dev")
1262 basename=$(basename "$realdev")
1263
1264 if [[ -b "$realdev" ]]; then
1265         major=$((0x$(stat -L -c '%t' "$realdev"))) || exit $?
1266         minor=$((0x$(stat -L -c '%T' "$realdev"))) || exit $?
1267         disk_size=$(($(<"/sys/dev/block/$major:$minor/size")*512))
1268
1269         # When the target is a partition device, get basename of its
1270         # holder device to access sysfs path of the holder device
1271         if [[ -r "/sys/dev/block/$major:$minor/partition" ]]; then
1272                 realsysfs=$(readlink "/sys/dev/block/$major:$minor")
1273                 basename=$(basename "${realsysfs%/*}")
1274         fi
1275         logical_block_size=$(<"/sys/block/$basename/queue/logical_block_size")
1276         case "$(<"/sys/class/block/$basename/queue/zoned")" in
1277         host-managed|host-aware)
1278                 is_zbd=true
1279                 if ! check_blkzone "${dev}"; then
1280                         exit 1
1281                 fi
1282                 if ! result=($(first_sequential_zone "$dev")); then
1283                         echo "Failed to determine first sequential zone"
1284                         exit 1
1285                 fi
1286                 first_sequential_zone_sector=${result[0]}
1287                 sectors_per_zone=${result[1]}
1288                 zone_size=$((sectors_per_zone * 512))
1289                 if ! max_open_zones=$(max_open_zones "$dev"); then
1290                         echo "Failed to determine maximum number of open zones"
1291                         exit 1
1292                 fi
1293                 set_io_scheduler "$basename" deadline || exit $?
1294                 if [ -n "$reset_all_zones" ]; then
1295                         reset_zone "$dev" -1
1296                 fi
1297                 ;;
1298         *)
1299                 first_sequential_zone_sector=$(((disk_size / 2) &
1300                                                 (logical_block_size - 1)))
1301                 zone_size=$(max 65536 "$logical_block_size")
1302                 sectors_per_zone=$((zone_size / 512))
1303                 max_open_zones=128
1304                 set_io_scheduler "$basename" none || exit $?
1305                 ;;
1306         esac
1307 elif [[ -c "$realdev" ]]; then
1308         # For an SG node, we must have libzbc option specified
1309         if [[ ! -n "$use_libzbc" ]]; then
1310                 echo "Character device files can only be used with -l (libzbc) option"
1311                 exit 1
1312         fi
1313
1314         if ! $(is_zbc "$dev"); then
1315                 echo "Device is not a ZBC disk"
1316                 exit 1
1317         fi
1318         is_zbd=true
1319
1320         if ! disk_size=($(( $(zbc_disk_sectors "$dev") * 512))); then
1321                 echo "Failed to determine disk size"
1322                 exit 1
1323         fi
1324         if ! logical_block_size=($(zbc_logical_block_size "$dev")); then
1325                 echo "Failed to determine logical block size"
1326                 exit 1
1327         fi
1328         if ! result=($(first_sequential_zone "$dev")); then
1329                 echo "Failed to determine first sequential zone"
1330                 exit 1
1331         fi
1332         first_sequential_zone_sector=${result[0]}
1333         sectors_per_zone=${result[1]}
1334         zone_size=$((sectors_per_zone * 512))
1335         if ! max_open_zones=$(max_open_zones "$dev"); then
1336                 echo "Failed to determine maximum number of open zones"
1337                 exit 1
1338         fi
1339         if [ -n "$reset_all_zones" ]; then
1340                 reset_zone "$dev" -1
1341         fi
1342 fi
1343
1344 if [[ -n ${max_open_zones_opt} ]]; then
1345         # Override max_open_zones with the script option value
1346         max_open_zones="${max_open_zones_opt}"
1347         global_var_opts+=("--ignore_zone_limits=1")
1348         job_var_opts+=("--max_open_zones=${max_open_zones_opt}")
1349 fi
1350
1351 echo -n "First sequential zone starts at sector $first_sequential_zone_sector;"
1352 echo " zone size: $((zone_size >> 20)) MB"
1353
1354 if [ "${#tests[@]}" = 0 ]; then
1355     readarray -t tests < <(declare -F | grep "test[0-9]*" | \
1356                                    tr -c -d "[:digit:]\n" | sort -n)
1357 fi
1358
1359 logfile=$0.log
1360
1361 passed=0
1362 skipped=0
1363 failed=0
1364 if [ -t 1 ]; then
1365     red="\e[1;31m"
1366     green="\e[1;32m"
1367     cyan="\e[1;36m"
1368     end="\e[m"
1369 else
1370     red=""
1371     green=""
1372     end=""
1373 fi
1374 rc=0
1375
1376 intr=0
1377 trap 'intr=1' SIGINT
1378 ret=0
1379
1380 for test_number in "${tests[@]}"; do
1381     rm -f "${logfile}.${test_number}"
1382     unset SKIP_REASON
1383     echo -n "Running test $(printf "%02d" $test_number) ... "
1384     eval "test$test_number"
1385     ret=$?
1386     if ((!ret)) && check_log $test_number; then
1387         status="PASS"
1388         cc_status="${green}${status}${end}"
1389         ((passed++))
1390     elif ((ret==SKIP_TESTCASE)); then
1391         status="SKIP"
1392         echo "${SKIP_REASON}" >> "${logfile}.${test_number}"
1393         cc_status="${cyan}${status}${end}    ${SKIP_REASON}"
1394         ((skipped++))
1395     else
1396         status="FAIL"
1397         cc_status="${red}${status}${end}"
1398         ((failed++))
1399         rc=1
1400     fi
1401     echo -e "$cc_status"
1402     echo "$status" >> "${logfile}.${test_number}"
1403     [ $intr -ne 0 ] && exit 1
1404     [ -n "$quit_on_err" -a "$rc" -ne 0 ] && exit 1
1405 done
1406
1407 echo "$passed tests passed"
1408 if [ $skipped -gt 0 ]; then
1409     echo " $skipped tests skipped"
1410 fi
1411 if [ $failed -gt 0 ]; then
1412     echo " $failed tests failed"
1413 fi
1414 echo "Run time: $(TZ=UTC0 printf "%(%H:%M:%S)T\n" $(( SECONDS )) )"
1415 exit $rc